
; Asar directives
hirom


; =============================[ Optimizations ]===============================

org $C358DE

; Build Lore list
C358DE:  LDA #$02        ; Lores: 24
         LDX #$1D29      ; Known Lores adr

; Build a list of learned skills
bldskl:  STA $E1         ; Set byte count			<- Could use stack
         LDY #$9D89      ; 7E/9D89
         STY $2181       ; Set WRAM LBs
         STZ $E0         ; Skill number: 0
.loop1   LDY #$0008      ; Skills left: 8
         LDA $00,X       ; 8 known skills
.loop2   LSR A           ; Knowing current?
         PHA             ; Save 8 skills
         LDA $E0         ; Skill number
         BCS .store      ; Retain if known
         LDA #$FF        ; Skill: None
.store   STA $2180       ; Add to list
         INC $E0         ; Skill number +1
         PLA             ; 8 known skills
         DEY             ; Skills left -1
         BNE .loop2      ; Loop till last
         INX             ; Point to next 8
         DEC $E1         ; One less byte
         BPL .loop1      ; Loop till last
         RTS

warnpc $C3590B : print pc, " / C3590B [Build Lore or skill list]"

; -----------------------------------------------------------------------------

org $C359C9

; Build SwdTech list
C359C9:  LDX #$1CF7      ; Known techs adr
         JMP bldskl      ; Build tech list
C359C_:

; -----------------------------------------------------------------------------

org $C35AE0

; Build sorted esper list
C35AE0:  LDA #$03        ; Espers: 32
         LDX #$1A69      ; Owned espers adr
         JSR bldskl      ; Build basic list

; Fork: Move unsorted list to a buffer
         LDX #$001F      ; Esper slot: 32
.loop    LDA $7E9D89,X   ; Esper in slot
         STA $7E9DED,X   ; Copy to buffer			<- Could use stack instead, with some changes
         LDA #$FF        ; Esper: None
         STA $7E9D89,X   ; Clear src slot
         DEX             ; Esper slot -1
         BPL .loop       ; Loop till < 0

; Fork: Sort esper list
C35B1D:  TDC             ; Clear A
         LDX #$001A      ; Buffer slot: 27			<- Ignores 5 unused esper bits, unlike code above (vanilla game does it this way)
C35B27:  PHX             ; Save src slot
         LDA $7E9DED,X   ; Esper in slot
         BMI C35B39      ; Skip if none
         PHA             ; Memorize it
         TAX             ; Index it
         LDA $D1F9B5,X   ; Intended slot
         DEC A           ; Subtract 1				<- Could remove this and use STA $7E9D88,X
         TAX             ; Index it
         PLA             ; Esper number
         STA $7E9D89,X   ; Add to new list
C35B39:  PLX             ; Source slot
         DEX             ; Source slot -1
         BPL C35B27      ; Loop till < 0
         RTS
C35AE_:

; -----------------------------------------------------------------------------

org $C35C78

; Build Blitz list
C35C78:  LDX #$1D28      ; Known Blitzes adr
         BRA C35C80      ; Skip a line

; Build Dance list
C35C7D:  LDX #$1D4C      ; Known Dances adr
C35C80:  TDC             ; Skills: 8
         JMP bldskl      ; Build skill list
C35C7_:


; =============================[ Segment edits ]===============================

org $C3222F

; Initialize Rage menu
         INC $3A         ; BG2 X-Pos: 256			<- Both INCs are optimizations to insert JSR
         INC $3E         ; BG3 X-Pos: 256
         JSR ragemet     ; List enemies met

warnpc $C32236


; ==========================[ Rage menu redesign ]=============================

org C35C7_

; Build list of enemies roaming Veldt
ragemet: LDX #$00FF      ; Slot: Last
         TXA             ; Enemy: None
.loop1   STA $7EAA8D,X   ; Clear slot
         DEX             ; List slot -1
         BPL .loop1      ; Loop till < 0

; Fork: Build list of encountered enemies
         INX             ; 8-pack index: 0
         STX $E0         ; Group index: 0

; Fork: Mark enemies met from 8 groups
.loop2   LDY #$0008      ; Groups left: 8
         LDA $1DDD,X     ; 8 met-group flags
         JSR mark6x8     ; Mark enemies met

; Fork: Handle next 8-group pack
         BNE .loop2      ; If not last pack
         RTS

warnpc $C35CA0 : print pc, " / C35CA0 [List enemies met]"



org C35AE_

; Mark Rage-compatible enemies in 8 groups as met
mark6x8: PHX             ; Save pack index
.loop1   LSR A           ; Met current group?
         PHY             ; Save group counter
         PHA             ; Save group flags
         BCC .next       ; Skip if not
         TDC             ; Clear A
         LDX $E0         ; Group data index
         LDY #$0006      ; Enemies: 6
         JSR mark6x1     ; Mark enemies met

; Fork: Handle next group from 8-pack
.next    LDA #$0F        ; Loop counter
         LDY $E0         ; Group data index
.loop2   INY             ; Index +1
         DEC A           ; Counter -1
         BNE .loop2      ; Loop till 0
         STY $E0         ; Save updated index
         PLA             ; 8 met-group flags
         PLY             ; Groups remaining
         DEY             ; One less group
         BNE .loop1      ; Loop till 8th
         PLX             ; Pack index
         INX             ; Pack index +1
         CPX #$0040      ; Done all 64?
         RTS

warnpc $C35B3D : print pc, " / C35B3D [Include 8 groups]"



org C359C_

; Mark Rage-compatible enemies in group as met
mark6x1: LDA $CF620E,X   ; 6 enemy num MSB
.loop    LSR A           ; Enemy num > 255?
         BCS .next       ; Skip enemy if so
         PHX             ; Save enemy slot
         PHA             ; Save nums MSBs
         LDA $CF6202,X   ; Enemy number
         TAX             ; Index it
         INC A           ; Pugs?
         BEQ .store      ; Branch if so				<- Stores #$00 for Pugs instead of #$FF (null value)
         TXA             ; Enemy number
.store   STA $7EAA8D,X   ; Mark enemy as met
         PLA             ; 6 enemy num MSB
         PLX             ; Enemy slot
.next    INX             ; Enemy slot +1
         DEY             ; One less enemy
         BNE .loop       ; Loop till 6th
         RTS

warnpc $C359EC : print pc, " / C359EC [Include 1 group]"

; -----------------------------------------------------------------------------

org $C35A73

; Draw Rage name
C35A73:  LDA $E6         ; BG1 write row
         JSR $8820       ; Compute map ptr
         TAY             ; Put it in Y
         JSR $35E1       ; Set position
         JSR rgcolor     ; Define color

; Fork: Blank slot if inaccessible Rage
         TXA             ; Enemy number
         BEQ .draw       ; Draw if Guard			<- Allows user to use its value to dummy out entries in table of Rage slots to leave blank
         LDX #$0003      ; Ban table index
.loop    CMP.L rg_ban,X  ; Banned Rage?
         BEQ C35A95      ; Blank if so
         DEX             ; Table index -1
         BPL .loop       ; Loop till < 0

; Fork: Draw Rage name
.draw    JSR $8BF2       ; Load name
         JMP $87B9       ; Draw name

; Fork: Blank Rage slot
C35A95:  JMP $5BB6       ; Draw 12 spaces			<- Reuses Esper menu code to save space (only need 8 spaces)

; Rage slots to leave blank					<- To remove a list entry, change it to "db $00"
rg_ban:  db $37          ; Siegfried
         db $40          ; Chupon
         db $BB          ; Allo Ver
         db $FF          ; Pugs

C35A7_:

warnpc $C35AAC

; -----------------------------------------------------------------------------

org $C35A1C

; Build Rage list
C35A1C:  LDA #$1F        ; Rages: 256
         LDX #$1D2C      ; Known Rages adr
         JSR bldskl      ; Build Rage list
         BCC .exit       ; If missing Pugs
;        TDC             ; Non-null value
         STA $7E9E88     ; Unlock Pugs Rage
.exit    RTS

; Define Rage's text color
rgcolor: JSR $D24D       ; Color: User's
         JSR $57BB       ; Rage in slot
         INC A           ; Learned it?
         BNE .exit       ; Lit if so
         LDA #$28        ; Palette 2
         STA $29         ; Color: Gray
         TXA             ; Enemy number
         CMP #$FF        ; Pugs?
         BNE .skip       ; Retain if not
         TDC             ; Pugs's tbl value			<- Table value is defined in "mark6x1" function above
.skip    CMP $7EAA8D,X   ; Roams Veldt now?
         BNE .exit       ; Gray out if not
         LDA #$24        ; Palette 1				<- Use #$2C for gray-and-blue palette from Magic menu
         STA $29         ; Color: Turquoise
.exit    RTS

warnpc $C35A49 : print pc, " / C35A49 [Rage list, color]"


; =======================[ Unlock Rage menu by default ]=======================

org $C3542B ; Unlock "Rage" by default
         PLX            ; Actor's address			<- Formerly PLY, allows for LDA $0000,Y -> LDA $00,X below
         JSR unlk_rg    ; Call fn below


org C35A7_

; Unlock Rage menu by default
unlk_rg: LDA #$20        ; Color: User's
         STA $7E         ; Unlock submenu
         LDA $00,X       ; Actor				<- Code removed from function above to insert JSR there
         RTS

warnpc $C35AAC : print pc, " / C35AAC [Draw 1 Rage, etc.]"
